﻿using C1.Win.C1FlexGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FlexGrid.RTL_Columns
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            InitData();

            c1FlexGrid1.DrawMode = DrawModeEnum.OwnerDraw;
            c1FlexGrid1.OwnerDrawCell += C1FlexGrid1_OwnerDrawCell;
        }

        private void InitData()
        {
            c1FlexGrid1.DataSource = GetDataTable();

            c1FlexGrid1.Cols[3].Editor = new TextBox() { RightToLeft = RightToLeft.Yes, BorderStyle = BorderStyle.None };
        }

        private DataTable GetDataTable()
        {
            DataTable table = new DataTable();
            table.Columns.Add("English");
            table.Columns.Add("English2");
            table.Columns.Add("Arabic");

            for (int i = 0; i < 5; ++i)
            {
                table.Rows.Add("One", "One", "واحد");
                table.Rows.Add("Two", "Two", "اثنان");
                table.Rows.Add("Three", "Three", "ثلاثة");
                table.Rows.Add("Four", "Four", "أربعة");
                table.Rows.Add("Five", "Five", "خمسة");
            }

            return table;
        }

        private void C1FlexGrid1_OwnerDrawCell(object sender, OwnerDrawCellEventArgs e)
        {
            if (e.Col == 3 && e.Row >= c1FlexGrid1.Rows.Fixed)
            {
                string text = e.Text;
                Font font = e.Style.Font;
                Color foreColor = e.Style.ForeColor;
                RectangleF rect = e.Bounds;
                StringFormat format = new StringFormat(StringFormatFlags.DirectionRightToLeft);

                e.DrawCell(DrawCellFlags.All & ~DrawCellFlags.Content);
                e.Graphics.DrawString(text, font, new SolidBrush(foreColor), rect, format);
            }
        }
    }
}
